/* -LICENSE-START-
 ** Copyright (c) 2023 Blackmagic Design
 **
 ** Permission is hereby granted, free of charge, to any person or organization
 ** obtaining a copy of the software and accompanying documentation (the
 ** "Software") to use, reproduce, display, distribute, sub-license, execute,
 ** and transmit the Software, and to prepare derivative works of the Software,
 ** and to permit third-parties to whom the Software is furnished to do so, in
 ** accordance with:
 **
 ** (1) if the Software is obtained from Blackmagic Design, the End User License
 ** Agreement for the Software Development Kit (“EULA”) available at
 ** https://www.blackmagicdesign.com/EULA/DeckLinkSDK; or
 **
 ** (2) if the Software is obtained from any third party, such licensing terms
 ** as notified by that third party,
 **
 ** and all subject to the following:
 **
 ** (3) the copyright notices in the Software and this entire statement,
 ** including the above license grant, this restriction and the following
 ** disclaimer, must be included in all copies of the Software, in whole or in
 ** part, and all derivative works of the Software, unless such copies or
 ** derivative works are solely in the form of machine-executable object code
 ** generated by a source language processor.
 **
 ** (4) THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 ** OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 ** FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 ** SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 ** FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 ** ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 ** DEALINGS IN THE SOFTWARE.
 **
 ** A copy of the Software is available free of charge at
 ** https://www.blackmagicdesign.com/desktopvideo_sdk under the EULA.
 **
 ** -LICENSE-END-
 */

#import "Pyramid.h"

@implementation Pyramid

static const Vertex pyramidVertices[] =
{
// Pixel Positions,       RGBA colors.
{ {  0.0,  1.0,  0.0 },  { 1.0, 0.0, 0.0, 1.0 } },  // Top of front side - red
{ { -1.0, -1.0,  1.0 },  { 0.0, 1.0, 0.0, 1.0 } },  // Bottom left of front side - green
{ {  1.0, -1.0,  1.0 },  { 0.0, 0.0, 1.0, 1.0 } },  // Bottom right of front side - blue
{ {  0.0,  1.0,  0.0 },  { 1.0, 0.0, 0.0, 1.0 } },  // Top of right side - red
{ {  1.0, -1.0,  1.0 },  { 0.0, 0.0, 1.0, 1.0 } },  // Bottom left of right side - blue
{ {  1.0, -1.0, -1.0 },  { 0.0, 1.0, 0.0, 1.0 } },  // Bottom right of right side - green
{ {  0.0,  1.0,  0.0 },  { 1.0, 0.0, 0.0, 1.0 } },  // Top of rear side - red
{ {  1.0, -1.0, -1.0 },  { 0.0, 1.0, 0.0, 1.0 } },  // Bottom left of rear side - green
{ { -1.0, -1.0, -1.0 },  { 0.0, 0.0, 1.0, 1.0 } },  // Bottom right of rear side - blue
{ {  0.0,  1.0,  0.0 },  { 1.0, 0.0, 0.0, 1.0 } },  // Top of left side - red
{ { -1.0, -1.0, -1.0 },  { 0.0, 0.0, 1.0, 1.0 } },  // Bottom left of left side - blue
{ { -1.0, -1.0,  1.0 },  { 0.0, 1.0, 0.0, 1.0 } },  // Bottom right of left side - green
};

// Returns the vertices for the pyramid
+(const Vertex *)vertices
{
	return pyramidVertices;
}

// Returns the number of vertices for the pyramid
+(const NSUInteger)vertexCount
{
	return sizeof(pyramidVertices)/sizeof(pyramidVertices[0]);
}

+(const NSUInteger)byteSize
{
	return sizeof(pyramidVertices);
}

@end
